'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subscriber;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rxLite = require('rx-lite');

var _rxLite2 = _interopRequireDefault(_rxLite);

var _lodash = require('lodash.isfunction');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SubscriberWrapper = (function (_React$Component) {
  _inherits(SubscriberWrapper, _React$Component);

  function SubscriberWrapper(props) {
    _classCallCheck(this, SubscriberWrapper);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SubscriberWrapper).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(SubscriberWrapper, [{
    key: 'subscribeOnNext',
    value: function subscribeOnNext(observable) {
      var _this2 = this;

      this.disposable.add(observable.subscribeOnNext(function (stateChanges) {
        if (stateChanges) {
          _this2.setState(stateChanges);
        }
      }));
    }
  }, {
    key: 'subscribeToObservables',
    value: function subscribeToObservables(props) {
      var _this3 = this;

      if (this.disposable) {
        this.disposable.dispose();
      }

      this.disposable = new _rxLite2.default.CompositeDisposable();

      var observables = props.observables;
      var transformObservable = props.transformObservable;
      var forwardedProps = props.forwardedProps;

      var resolvedObservables = undefined;

      if ((0, _lodash2.default)(observables)) {
        (function () {
          var propsSubject = new _rxLite2.default.Subject();
          var observeProp = function observeProp(propID) {
            return propsSubject.map(function (props) {
              return props[propID];
            }).distinctUntilChanged();
          };
          resolvedObservables = observables({ observeProp: observeProp, allPropsObservable: propsSubject.asObservable() });
          _this3.propsSubject = propsSubject;
        })();
      } else {
        resolvedObservables = observables;
      }

      resolvedObservables.forEach(function (observable) {
        _this3.subscribeOnNext(transformObservable(observable));
      });

      if (this.propsSubject) {
        this.propsSubject.onNext(forwardedProps);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscribeToObservables(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.propsSubject) {
        this.propsSubject.onNext(nextProps.forwardedProps);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.disposable.dispose();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var Component = _props.component;
      var forwardedProps = _props.forwardedProps;

      return _react2.default.createElement(Component, _extends({}, forwardedProps, this.state));
    }
  }]);

  return SubscriberWrapper;
})(_react2.default.Component);

function reflect(input) {
  return input;
}

function subscriber(observables) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$transformObserva = _ref.transformObservable;
  var transformObservable = _ref$transformObserva === undefined ? reflect : _ref$transformObserva;

  return function (Component) {
    return function (props) {
      return _react2.default.createElement(SubscriberWrapper, { forwardedProps: props, observables: observables, transformObservable: transformObservable, component: Component });
    };
  };
}